'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _game_state = require('./game_state');

var _game_state2 = _interopRequireDefault(_game_state);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _spritesheet_builder = require('../spritesheet_builder');

var _spritesheet_builder2 = _interopRequireDefault(_spritesheet_builder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var numParticlesInExplosion = 200;
var emitParticlesInterval = 500;
var particlePoolSize = 5000;

var Particles = function (_GameState) {
  _inherits(Particles, _GameState);

  function Particles() {
    _classCallCheck(this, Particles);

    return _possibleConstructorReturn(this, (Particles.__proto__ || Object.getPrototypeOf(Particles)).apply(this, arguments));
  }

  _createClass(Particles, [{
    key: 'create',
    value: function create() {
      var _this2 = this;

      _get(Particles.prototype.__proto__ || Object.getPrototypeOf(Particles.prototype), 'create', this).call(this);

      this.buildTextureAtlas();

      this.addEmitter();

      this.game.time.events.loop(emitParticlesInterval, function () {
        _this2.emitter.emitX = _this2.game.rnd.integerInRange(0, _this2.game.world.width);
        _this2.emitter.emitY = _this2.game.rnd.integerInRange(0, _this2.game.world.height);
        _this2.emitter.start(true, 5000, null, numParticlesInExplosion);
      });
    }
  }, {
    key: 'buildTextureAtlas',
    value: function buildTextureAtlas() {
      var ssb = new _spritesheet_builder2.default(this.game);
      ssb.addFrame('square', this.addSquare());
      ssb.addFrame('triangle', this.addTriangle());
      ssb.addFrame('arc', this.addArc());

      ssb.buildToCache('new-atlas');
    }
  }, {
    key: 'addEmitter',
    value: function addEmitter() {
      this.emitter = this.game.add.emitter(this.game.world.centerX, 200, particlePoolSize);

      this.emitter.makeParticles('new-atlas', ['square', 'triangle', 'arc']);

      this.emitter.minParticleAlpha = 0;
      this.emitter.maxParticleAlpha = 1;
    }
  }, {
    key: 'addSquare',
    value: function addSquare() {
      var g = this.game.make.graphics();
      g.beginFill(0x4ebc96).drawRect(0, 0, 100, 100);
      return g.generateTexture();
    }
  }, {
    key: 'addTriangle',
    value: function addTriangle() {
      var g = this.game.make.graphics();
      g.beginFill(0xee9a2d).moveTo(0, 0).lineTo(100, 0).lineTo(0, 100).lineTo(0, 0);
      return g.generateTexture();
    }
  }, {
    key: 'addArc',
    value: function addArc() {
      var r = 50;
      var thickness = 20;
      var w = r * 2 + thickness;
      var bmd = this.game.add.bitmapData(w, w);
      var c = bmd.ctx;
      var offset = 0;
      c.setLineDash([2, 4]);
      c.lineWidth = thickness;
      c.beginPath();
      c.arc(w / 2, w / 2, r, offset, offset + (Phaser.Math.PI2 - offset * 2) * 1);
      c.strokeStyle = "#c1513a";
      c.stroke();
      c.closePath();
      return bmd.texture;
    }
  }]);

  return Particles;
}(_game_state2.default);

exports.default = Particles;